#!/bin/bash

# Note Need ipcalc pacakge 

OUTPUT_CONFIG_FILE=/etc/dhcp3/dhcpd.conf

LAN_IP_ADDRESS=`cat config.ini | grep -i LAN_IP_ADDRESS | cut -d "=" -f 2 | awk {'print $1'}`
LAN_NETMASK=`cat config.ini | grep -i LAN_NETMASK | cut -d "=" -f 2 | awk {'print $1'}`
LAN_DNS1=`cat config.ini | grep -i LAN_DNS1 | cut -d "=" -f 2 | awk {'print $1'}`
LAN_DNS2=`cat config.ini | grep -i LAN_DNS2 | cut -d "=" -f 2 | awk {'print $1'}`

LAN_NETWORK=`ipcalc $LAN_IP_ADDRESS/$LAN_NETMASK | grep Network | awk {'print $2'} | cut -d "/" -f 1`
LAN_NETWORK2=`ipcalc $LAN_IP_ADDRESS/$LAN_NETMASK | grep Network | awk {'print $2'} | cut -d "." -f 1-3`
DHCP_START_IP=`cat config.ini | grep -i DHCP_START_IP | cut -d "=" -f 2 | awk {'print $1'}`
DHCP_END_IP=`cat config.ini | grep -i DHCP_END_IP | cut -d "=" -f 2 | awk {'print $1'}`

### Config DHCP Server File ###
echo "# This file is auto generate by xxxkung script" > $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "ddns-update-style none;" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "option domain-name \"hadyaiinternet.com\";" >> $OUTPUT_CONFIG_FILE
echo "option domain-name-servers $LAN_IP_ADDRESS , $LAN_DNS1 , $LAN_DNS2;" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "default-lease-time 600;" >> $OUTPUT_CONFIG_FILE
echo "max-lease-time 7200;" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "log-facility local7;" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "# Pool DHCP" >> $OUTPUT_CONFIG_FILE
echo "subnet $LAN_NETWORK netmask $LAN_NETMASK {" >> $OUTPUT_CONFIG_FILE
echo "          default-lease-time 43200;" >> $OUTPUT_CONFIG_FILE
echo "          max-lease-time 86400;" >> $OUTPUT_CONFIG_FILE
echo "          allow unknown-clients;" >> $OUTPUT_CONFIG_FILE
echo "          option domain-name-servers $LAN_IP_ADDRESS , $LAN_DNS1 , $LAN_DNS2;" >> $OUTPUT_CONFIG_FILE
echo "          option routers $LAN_IP_ADDRESS;" >> $OUTPUT_CONFIG_FILE
echo "          range $LAN_NETWORK2.$DHCP_START_IP $LAN_NETWORK2.$DHCP_END_IP;" >> $OUTPUT_CONFIG_FILE
echo "          }" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE

echo "Make /etc/dhcp3/dhcpd.conf       ..done."
