#!/bin/bash

OUTPUT_CONFIG_FILE=/etc/frox.conf

LAN_INTERFACE=`cat config.ini | grep -i LAN_INTERFACE | cut -d "=" -f 2 | awk {'print $1'}`
FROX_CACHE_SIZE=`cat config.ini | grep -i FROX_CACHE_SIZE | cut -d "=" -f 2 | awk {'print $1'}`

### Frox Config File ###
echo "# This file is auto generate by xxxkung script" > $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "Port 2121" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "BindToDevice $LAN_INTERFACE" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "ResolvLoadHack wontresolve.doesntexist.abc" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "User nobody" >> $OUTPUT_CONFIG_FILE
echo "Group nogroup" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "WorkingDir /var/spool/frox" >> $OUTPUT_CONFIG_FILE
echo "DontChroot Yes" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "LogLevel 20" >> $OUTPUT_CONFIG_FILE
echo "LogFile /var/log/frox.log" >> $OUTPUT_CONFIG_FILE
echo "XferLogging no" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "PidFile /var/run/frox.pid" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "BounceDefend yes" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "ControlPorts 50000-50199" >> $OUTPUT_CONFIG_FILE
echo "PassivePorts 50200-50399" >> $OUTPUT_CONFIG_FILE
echo "ActivePorts  50400-50599" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "CacheModule local" >> $OUTPUT_CONFIG_FILE
echo "CacheSize $FROX_CACHE_SIZE" >> $OUTPUT_CONFIG_FILE
echo "CacheAll yes" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "DoNTP yes" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "MaxForks 80" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "MaxForksPerHost 60" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "ACL Allow * - *" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "StrictCaching yes" >> $OUTPUT_CONFIG_FILE

echo "Make /etc/frox.conf              ..done."
