#!/bin/bash

OUTPUT_CONFIG_FILE=/etc/init.d/0route.sh

LAN_INTERFACE=`cat config.ini | grep -i LAN_INTERFACE | cut -d "=" -f 2 | awk {'print $1'}`
LAN_IP_ADDRESS=`cat config.ini | grep -i LAN_IP_ADDRESS | cut -d "=" -f 2 | awk {'print $1'}`
LAN_NETMASK=`cat config.ini | grep -i LAN_NETMASK | cut -d "=" -f 2 | awk {'print $1'}`
LAN_NETWORK=`ipcalc $LAN_IP_ADDRESS/$LAN_NETMASK | grep Network | awk {'print $2'}`
WAN1_TYPE=`cat config.ini | grep -i WAN1_TYPE | cut -d "=" -f 2 | awk {'print $1'}`
WAN2_TYPE=`cat config.ini | grep -i WAN2_TYPE | cut -d "=" -f 2 | awk {'print $1'}`
WAN3_TYPE=`cat config.ini | grep -i WAN3_TYPE | cut -d "=" -f 2 | awk {'print $1'}`
WAN4_TYPE=`cat config.ini | grep -i WAN4_TYPE | cut -d "=" -f 2 | awk {'print $1'}`
WAN1_WEIGHT=`cat config.ini | grep -i WAN1_WEIGHT | cut -d "=" -f 2 | awk {'print $1'}`
WAN2_WEIGHT=`cat config.ini | grep -i WAN2_WEIGHT | cut -d "=" -f 2 | awk {'print $1'}`
WAN3_WEIGHT=`cat config.ini | grep -i WAN3_WEIGHT | cut -d "=" -f 2 | awk {'print $1'}`
WAN4_WEIGHT=`cat config.ini | grep -i WAN4_WEIGHT | cut -d "=" -f 2 | awk {'print $1'}`

GW1_NAME="dev ppp101"
GW2_NAME="dev ppp102"
GW3_NAME="dev ppp103"
GW4_NAME="dev ppp104"

GW1_NAME2="dev ppp101 weight $WAN1_WEIGHT"
GW2_NAME2="dev ppp102 weight $WAN2_WEIGHT"
GW3_NAME2="dev ppp103 weight $WAN3_WEIGHT"
GW4_NAME2="dev ppp104 weight $WAN4_WEIGHT"

if [ "$WAN1_TYPE" == "static" ]; then
     WAN1_INTERFACE=`cat config.ini | grep -i WAN1_INTERFACE | cut -d "=" -f 2 | awk {'print $1'}`
     WAN1_STATIC_GATEWAY=`cat config.ini | grep -i WAN1_STATIC_GATEWAY | cut -d "=" -f 2 | awk {'print $1'}`
     GW1_NAME="via $WAN1_STATIC_GATEWAY dev $WAN1_INTERFACE"
     GW1_NAME2="via $WAN1_STATIC_GATEWAY dev $WAN1_INTERFACE weight $WAN1_WEIGHT"
fi

if [ "$WAN2_TYPE" == "static" ]; then
     WAN2_INTERFACE=`cat config.ini | grep -i WAN2_INTERFACE | cut -d "=" -f 2 | awk {'print $1'}`
     WAN2_STATIC_GATEWAY=`cat config.ini | grep -i WAN2_STATIC_GATEWAY | cut -d "=" -f 2 | awk {'print $1'}`
     GW2_NAME="via $WAN2_STATIC_GATEWAY dev $WAN2_INTERFACE"
     GW2_NAME2="via $WAN2_STATIC_GATEWAY dev $WAN2_INTERFACE weight $WAN2_WEIGHT"
fi

if [ "$WAN3_TYPE" == "static" ]; then
     WAN3_INTERFACE=`cat config.ini | grep -i WAN3_INTERFACE | cut -d "=" -f 2 | awk {'print $1'}`
     WAN3_STATIC_GATEWAY=`cat config.ini | grep -i WAN3_STATIC_GATEWAY | cut -d "=" -f 2 | awk {'print $1'}`
     GW3_NAME="via $WAN3_STATIC_GATEWAY dev $WAN3_INTERFACE"
     GW3_NAME2="via $WAN3_STATIC_GATEWAY dev $WAN3_INTERFACE weight $WAN3_WEIGHT"
fi

if [ "$WAN4_TYPE" == "static" ]; then
     WAN4_INTERFACE=`cat config.ini | grep -i WAN4_INTERFACE | cut -d "=" -f 2 | awk {'print $1'}`
     WAN4_STATIC_GATEWAY=`cat config.ini | grep -i WAN4_STATIC_GATEWAY | cut -d "=" -f 2 | awk {'print $1'}`
     GW4_NAME="via $WAN4_STATIC_GATEWAY dev $WAN4_INTERFACE"
     GW4_NAME2="via $WAN4_STATIC_GATEWAY dev $WAN4_INTERFACE weight $WAN4_WEIGHT"
fi

### Config tableroute.sh File ###
echo "#!/bin/bash" > $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "# This file is auto generate by xxxkung script" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "if [ \"\$1\" == \"\" ]; then" >> $OUTPUT_CONFIG_FILE
echo "     echo Please Input Link Status !!!" >> $OUTPUT_CONFIG_FILE
echo "else" >> $OUTPUT_CONFIG_FILE
echo "     LinkStatus=\$1" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "     GW00_DEF=\`ip route show | grep default\`" >> $OUTPUT_CONFIG_FILE
echo "     GW10_DEF=\`ip route show table 10 | grep default\`" >> $OUTPUT_CONFIG_FILE
echo "     GW20_DEF=\`ip route show table 20 | grep default\`" >> $OUTPUT_CONFIG_FILE
echo "     GW30_DEF=\`ip route show table 30 | grep default\`" >> $OUTPUT_CONFIG_FILE
echo "     GW40_DEF=\`ip route show table 40 | grep default\`" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "     if [ -n \"\$GW00_DEF\" ]; then" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "           ip route del default" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "     fi" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "     if [ -n \"\$GW10_DEF\" ]; then" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "           ip route del table 10 default" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "     fi" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "     if [ -n \"\$GW20_DEF\" ]; then" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "           ip route del table 20 default" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "     fi" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "     if [ -n \"\$GW30_DEF\" ]; then" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "           ip route del table 30 default" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "     fi" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "     if [ -n \"\$GW40_DEF\" ]; then" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "           ip route del table 40 default" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "     fi" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE


ST="1111 1110 1101 1100 1011 1010 1001 1000 0111 0110 0101 0100 0011 0010 0001"

for i in $ST; do
     CONFIG_GW_GAME1=`cat config.ini | grep -i LINK_$i | cut -d "|" -f 3 | awk {'print $1'}`
     CONFIG_GW_GAME2=`cat config.ini | grep -i LINK_$i | cut -d "|" -f 4 | awk {'print $1'}`
     CONFIG_GW_GAME3=`cat config.ini | grep -i LINK_$i | cut -d "|" -f 5 | awk {'print $1'}`
     CONFIG_GW_WEB=`cat config.ini | grep -i LINK_$i | cut -d "|" -f 6 | awk {'print $1'}`
     CONFIG_GW_DEF=`cat config.ini | grep -i LINK_$i | cut -d "|" -f 6 | awk {'print $1'}`

     GW1=`echo $CONFIG_GW_GAME1 | cut -b 1`
     GW2=`echo $CONFIG_GW_GAME1 | cut -b 2`
     GW3=`echo $CONFIG_GW_GAME1 | cut -b 3`
     GW4=`echo $CONFIG_GW_GAME1 | cut -b 4`

     MULTI=`expr $GW1 + $GW2 + $GW3 + $GW4`

     if [ $MULTI -gt 1 ]; then
           GW_TABLE_10="equalize "
           if [ "$GW1" == "1" ]; then
                 GW_TABLE_10="$GW_TABLE_10 nexthop $GW1_NAME2"
           fi
           if [ "$GW2" == "1" ]; then
                 GW_TABLE_10="$GW_TABLE_10 nexthop $GW2_NAME2"
           fi
           if [ "$GW3" == "1" ]; then
                 GW_TABLE_10="$GW_TABLE_10 nexthop $GW3_NAME2"
           fi
           if [ "$GW4" == "1" ]; then
                 GW_TABLE_10="$GW_TABLE_10 nexthop $GW4_NAME2"
           fi
     else
           GW_TABLE_10=""
           if [ "$GW1" == "1" ]; then
                 GW_TABLE_10="$GW_TABLE_10 $GW1_NAME"
           fi
           if [ "$GW2" == "1" ]; then
                 GW_TABLE_10="$GW_TABLE_10 $GW2_NAME"
           fi
           if [ "$GW3" == "1" ]; then
                 GW_TABLE_10="$GW_TABLE_10 $GW3_NAME"
           fi
           if [ "$GW4" == "1" ]; then
                 GW_TABLE_10="$GW_TABLE_10 $GW4_NAME"
           fi
     fi

     GW1=`echo $CONFIG_GW_GAME2 | cut -b 1`
     GW2=`echo $CONFIG_GW_GAME2 | cut -b 2`
     GW3=`echo $CONFIG_GW_GAME2 | cut -b 3`
     GW4=`echo $CONFIG_GW_GAME2 | cut -b 4`

     MULTI=`expr $GW1 + $GW2 + $GW3 + $GW4`

     if [ $MULTI -gt 1 ]; then
           GW_TABLE_20="equalize "
           if [ "$GW1" == "1" ]; then
                 GW_TABLE_20="$GW_TABLE_20 nexthop $GW1_NAME2"
           fi
           if [ "$GW2" == "1" ]; then
                 GW_TABLE_20="$GW_TABLE_20 nexthop $GW2_NAME2"
           fi
           if [ "$GW3" == "1" ]; then
                 GW_TABLE_20="$GW_TABLE_20 nexthop $GW3_NAME2"
           fi
           if [ "$GW4" == "1" ]; then
                 GW_TABLE_20="$GW_TABLE_20 nexthop $GW4_NAME2"
           fi
     else
           GW_TABLE_20=""
           if [ "$GW1" == "1" ]; then
                 GW_TABLE_20="$GW_TABLE_20 $GW1_NAME"
           fi
           if [ "$GW2" == "1" ]; then
                 GW_TABLE_20="$GW_TABLE_20 $GW2_NAME"
           fi
           if [ "$GW3" == "1" ]; then
                 GW_TABLE_20="$GW_TABLE_20 $GW3_NAME"
           fi
           if [ "$GW4" == "1" ]; then
                 GW_TABLE_20="$GW_TABLE_20 $GW4_NAME"
           fi
     fi

     GW1=`echo $CONFIG_GW_GAME3 | cut -b 1`
     GW2=`echo $CONFIG_GW_GAME3 | cut -b 2`
     GW3=`echo $CONFIG_GW_GAME3 | cut -b 3`
     GW4=`echo $CONFIG_GW_GAME3 | cut -b 4`

     MULTI=`expr $GW1 + $GW2 + $GW3 + $GW4`

     if [ $MULTI -gt 1 ]; then
           GW_TABLE_30="equalize "
           if [ "$GW1" == "1" ]; then
                 GW_TABLE_30="$GW_TABLE_30 nexthop $GW1_NAME2"
           fi
           if [ "$GW2" == "1" ]; then
                 GW_TABLE_30="$GW_TABLE_30 nexthop $GW2_NAME2"
           fi
           if [ "$GW3" == "1" ]; then
                 GW_TABLE_30="$GW_TABLE_30 nexthop $GW3_NAME2"
           fi
           if [ "$GW4" == "1" ]; then
                 GW_TABLE_30="$GW_TABLE_30 nexthop $GW4_NAME2"
           fi
     else
           GW_TABLE_30=""
           if [ "$GW1" == "1" ]; then
                 GW_TABLE_30="$GW_TABLE_30 $GW1_NAME"
           fi
           if [ "$GW2" == "1" ]; then
                 GW_TABLE_30="$GW_TABLE_30 $GW2_NAME"
           fi
           if [ "$GW3" == "1" ]; then
                 GW_TABLE_30="$GW_TABLE_30 $GW3_NAME"
           fi
           if [ "$GW4" == "1" ]; then
                 GW_TABLE_30="$GW_TABLE_30 $GW4_NAME"
           fi
     fi

     GW1=`echo $CONFIG_GW_WEB | cut -b 1`
     GW2=`echo $CONFIG_GW_WEB | cut -b 2`
     GW3=`echo $CONFIG_GW_WEB | cut -b 3`
     GW4=`echo $CONFIG_GW_WEB | cut -b 4`

     MULTI=`expr $GW1 + $GW2 + $GW3 + $GW4`

     if [ $MULTI -gt 1 ]; then
           GW_TABLE_40="equalize "
           if [ "$GW1" == "1" ]; then
                 GW_TABLE_40="$GW_TABLE_40 nexthop $GW1_NAME2"
           fi
           if [ "$GW2" == "1" ]; then
                 GW_TABLE_40="$GW_TABLE_40 nexthop $GW2_NAME2"
           fi
           if [ "$GW3" == "1" ]; then
                 GW_TABLE_40="$GW_TABLE_40 nexthop $GW3_NAME2"
           fi
           if [ "$GW4" == "1" ]; then
                 GW_TABLE_40="$GW_TABLE_40 nexthop $GW4_NAME2"
           fi
     else
           GW_TABLE_40=""
           if [ "$GW1" == "1" ]; then
                 GW_TABLE_40="$GW_TABLE_40 $GW1_NAME"
           fi
           if [ "$GW2" == "1" ]; then
                 GW_TABLE_40="$GW_TABLE_40 $GW2_NAME"
           fi
           if [ "$GW3" == "1" ]; then
                 GW_TABLE_40="$GW_TABLE_40 $GW3_NAME"
           fi
           if [ "$GW4" == "1" ]; then
                 GW_TABLE_40="$GW_TABLE_40 $GW4_NAME"
           fi
     fi

     GW1=`echo $CONFIG_GW_DEF | cut -b 1`
     GW2=`echo $CONFIG_GW_DEF | cut -b 2`
     GW3=`echo $CONFIG_GW_DEF | cut -b 3`
     GW4=`echo $CONFIG_GW_DEF | cut -b 4`

     MULTI=`expr $GW1 + $GW2 + $GW3 + $GW4`

     if [ $MULTI -gt 1 ]; then
           GW_TABLE_DEF="equalize "   
           if [ "$GW1" == "1" ]; then
                 GW_TABLE_DEF="$GW_TABLE_DEF nexthop $GW1_NAME2"
           fi
           if [ "$GW2" == "1" ]; then
                 GW_TABLE_DEF="$GW_TABLE_DEF nexthop $GW2_NAME2"
           fi
           if [ "$GW3" == "1" ]; then
                 GW_TABLE_DEF="$GW_TABLE_DEF nexthop $GW3_NAME2"
           fi
           if [ "$GW4" == "1" ]; then
                 GW_TABLE_DEF="$GW_TABLE_DEF nexthop $GW4_NAME2"
           fi
     else    
           GW_TABLE_DEF=""            
           if [ "$GW1" == "1" ]; then                
                 GW_TABLE_DEF="$GW_TABLE_DEF $GW1_NAME"
           fi
           if [ "$GW2" == "1" ]; then
                 GW_TABLE_DEF="$GW_TABLE_DEF $GW2_NAME"
           fi
           if [ "$GW3" == "1" ]; then
                 GW_TABLE_DEF="$GW_TABLE_DEF $GW3_NAME"
           fi
           if [ "$GW4" == "1" ]; then
                 GW_TABLE_DEF="$GW_TABLE_DEF $GW4_NAME"
           fi
     fi      

     echo >> $OUTPUT_CONFIG_FILE
     echo "     if [ \$LinkStatus -eq $i ]; then" >> $OUTPUT_CONFIG_FILE
     if [ "$i" != "0000" ]; then
          if [ "$GW_TABLE_DEF" != "" ]; then
               echo "           ip route add default $GW_TABLE_DEF" >> $OUTPUT_CONFIG_FILE
          fi

          if [ "$GW_TABLE_10" != "" ]; then
               echo "           ip route add table 10 default $GW_TABLE_10" >> $OUTPUT_CONFIG_FILE
          fi

          if [ "$GW_TABLE_20" != "" ]; then
               echo "           ip route add table 20 default $GW_TABLE_20" >> $OUTPUT_CONFIG_FILE
          fi

          if [ "$GW_TABLE_30" != "" ]; then
               echo "           ip route add table 30 default $GW_TABLE_30" >> $OUTPUT_CONFIG_FILE
          fi

          if [ "$GW_TABLE_40" != "" ]; then
               echo "           ip route add table 40 default $GW_TABLE_40" >> $OUTPUT_CONFIG_FILE
          fi

     fi
     echo "     fi" >> $OUTPUT_CONFIG_FILE
     echo >> $OUTPUT_CONFIG_FILE
done

echo "fi" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "ip route flush cache" >> $OUTPUT_CONFIG_FILE

echo >> $OUTPUT_CONFIG_FILE

chmod +x $OUTPUT_CONFIG_FILE

echo "Make /etc/init.d/0route.sh       ..done."
