#!/bin/bash

OUTPUT_CONFIG_FILE=/etc/init.d/checklink.sh

LAN_INTERFACE=`cat config.ini | grep -i LAN_INTERFACE | cut -d "=" -f 2 | awk {'print $1'}`
LAN_IP_ADDRESS=`cat config.ini | grep -i LAN_IP_ADDRESS | cut -d "=" -f 2 | awk {'print $1'}`
LAN_NETMASK=`cat config.ini | grep -i LAN_NETMASK | cut -d "=" -f 2 | awk {'print $1'}`
LAN_NETWORK=`ipcalc $LAN_IP_ADDRESS/$LAN_NETMASK | grep Network | awk {'print $2'}`
WAN1_TYPE=`cat config.ini | grep -i WAN1_TYPE | cut -d "=" -f 2 | awk {'print $1'}`
WAN2_TYPE=`cat config.ini | grep -i WAN2_TYPE | cut -d "=" -f 2 | awk {'print $1'}`
WAN3_TYPE=`cat config.ini | grep -i WAN3_TYPE | cut -d "=" -f 2 | awk {'print $1'}`
WAN4_TYPE=`cat config.ini | grep -i WAN4_TYPE | cut -d "=" -f 2 | awk {'print $1'}`

PING_CHECK_IP1=`cat config.ini | grep -i PING_CHECK_IP1 | cut -d "=" -f 2 | awk {'print $1'}`
PING_CHECK_IP2=`cat config.ini | grep -i PING_CHECK_IP2 | cut -d "=" -f 2 | awk {'print $1'}`
PING_CHECK_IP3=`cat config.ini | grep -i PING_CHECK_IP3 | cut -d "=" -f 2 | awk {'print $1'}`

WAN1_NAME=ppp101
WAN2_NAME=ppp102
WAN3_NAME=ppp103
WAN4_NAME=ppp104

WAN1_PING=ppp101
WAN2_PING=ppp102
WAN3_PING=ppp103
WAN4_PING=ppp104

if [ "$WAN1_TYPE" == "static" ]; then
     WAN1_INTERFACE=`cat config.ini | grep -i WAN1_INTERFACE | cut -d "=" -f 2 | awk {'print $1'}`
     WAN1_STATIC_IP_ADDRESS=`cat config.ini | grep -i WAN1_STATIC_IP_ADDRESS | cut -d "=" -f 2 | awk {'print $1'}`
     WAN1_NAME=$WAN1_INTERFACE
     WAN1_PING=$WAN1_STATIC_IP_ADDRESS
fi

if [ "$WAN2_TYPE" == "static" ]; then
     WAN2_INTERFACE=`cat config.ini | grep -i WAN2_INTERFACE | cut -d "=" -f 2 | awk {'print $1'}`
     WAN2_STATIC_IP_ADDRESS=`cat config.ini | grep -i WAN2_STATIC_IP_ADDRESS | cut -d "=" -f 2 | awk {'print $1'}`
     WAN2_NAME=$WAN2_INTERFACE
     WAN2_PING=$WAN2_STATIC_IP_ADDRESS
fi

if [ "$WAN3_TYPE" == "static" ]; then
     WAN3_INTERFACE=`cat config.ini | grep -i WAN3_INTERFACE | cut -d "=" -f 2 | awk {'print $1'}`
     WAN3_STATIC_IP_ADDRESS=`cat config.ini | grep -i WAN3_STATIC_IP_ADDRESS | cut -d "=" -f 2 | awk {'print $1'}`
     WAN3_NAME=$WAN3_INTERFACE
     WAN3_PING=$WAN3_STATIC_IP_ADDRESS
fi

if [ "$WAN4_TYPE" == "static" ]; then
     WAN4_INTERFACE=`cat config.ini | grep -i WAN4_INTERFACE | cut -d "=" -f 2 | awk {'print $1'}`
     WAN4_STATIC_IP_ADDRESS=`cat config.ini | grep -i WAN4_STATIC_IP_ADDRESS | cut -d "=" -f 2 | awk {'print $1'}`
     WAN4_NAME=$WAN4_INTERFACE
     WAN4_PING=$WAN4_STATIC_IP_ADDRESS
fi

### Config tableroute.sh File ###
echo "#!/bin/bash" > $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "# This file is auto generate by xxxkung script" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "oldstatus=0" >> $OUTPUT_CONFIG_FILE
echo "while [ 1 ]" >> $OUTPUT_CONFIG_FILE
echo "do" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "     ppp101=\`/sbin/ifconfig -a | grep \"$WAN1_NAME\"\`" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "     if [ -n \"\$ppp101\" ]; then" >> $OUTPUT_CONFIG_FILE
echo "          ping -I $WAN1_PING $PING_CHECK_IP1 -c 5 | grep time= > /tmp/testpingwan1.txt &" >> $OUTPUT_CONFIG_FILE
echo "          ping -I $WAN1_PING $PING_CHECK_IP2 -c 5 | grep time= >> /tmp/testpingwan1.txt &" >> $OUTPUT_CONFIG_FILE
echo "          ping -I $WAN1_PING $PING_CHECK_IP3 -c 5 | grep time= >> /tmp/testpingwan1.txt &" >> $OUTPUT_CONFIG_FILE
echo "     else" >> $OUTPUT_CONFIG_FILE
echo "          echo > /tmp/testpingwan1.txt" >> $OUTPUT_CONFIG_FILE
echo "     fi" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "     ppp102=\`/sbin/ifconfig -a | grep \"$WAN2_NAME\"\`" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "     if [ -n \"\$ppp102\" ]; then" >> $OUTPUT_CONFIG_FILE              
echo "          ping -I $WAN2_PING $PING_CHECK_IP1 -c 5 | grep time= > /tmp/testpingwan2.txt &" >> $OUTPUT_CONFIG_FILE    
echo "          ping -I $WAN2_PING $PING_CHECK_IP2 -c 5 | grep time= >> /tmp/testpingwan2.txt &" >> $OUTPUT_CONFIG_FILE    
echo "          ping -I $WAN2_PING $PING_CHECK_IP3 -c 5 | grep time= >> /tmp/testpingwan2.txt &" >> $OUTPUT_CONFIG_FILE    
echo "     else" >> $OUTPUT_CONFIG_FILE
echo "          echo > /tmp/testpingwan2.txt" >> $OUTPUT_CONFIG_FILE
echo "     fi" >> $OUTPUT_CONFIG_FILE  
echo >> $OUTPUT_CONFIG_FILE
echo "     ppp103=\`/sbin/ifconfig -a | grep \"$WAN3_NAME\"\`" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "     if [ -n \"\$ppp103\" ]; then" >> $OUTPUT_CONFIG_FILE              
echo "          ping -I $WAN3_PING $PING_CHECK_IP1 -c 5 | grep time= > /tmp/testpingwan3.txt &" >> $OUTPUT_CONFIG_FILE    
echo "          ping -I $WAN3_PING $PING_CHECK_IP2 -c 5 | grep time= >> /tmp/testpingwan3.txt &" >> $OUTPUT_CONFIG_FILE    
echo "          ping -I $WAN3_PING $PING_CHECK_IP3 -c 5 | grep time= >> /tmp/testpingwan3.txt &" >> $OUTPUT_CONFIG_FILE    
echo "     else" >> $OUTPUT_CONFIG_FILE
echo "          echo > /tmp/testpingwan3.txt" >> $OUTPUT_CONFIG_FILE
echo "     fi" >> $OUTPUT_CONFIG_FILE  
echo >> $OUTPUT_CONFIG_FILE
echo "     ppp104=\`/sbin/ifconfig -a | grep \"$WAN4_NAME\"\`" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "     if [ -n \"\$ppp104\" ]; then" >> $OUTPUT_CONFIG_FILE              
echo "          ping -I $WAN4_PING $PING_CHECK_IP1 -c 5 | grep time= > /tmp/testpingwan4.txt &" >> $OUTPUT_CONFIG_FILE    
echo "          ping -I $WAN4_PING $PING_CHECK_IP2 -c 5 | grep time= >> /tmp/testpingwan4.txt &" >> $OUTPUT_CONFIG_FILE    
echo "          ping -I $WAN4_PING $PING_CHECK_IP3 -c 5 | grep time= >> /tmp/testpingwan4.txt &" >> $OUTPUT_CONFIG_FILE    
echo "     else" >> $OUTPUT_CONFIG_FILE
echo "          echo > /tmp/testpingwan4.txt" >> $OUTPUT_CONFIG_FILE
echo "     fi" >> $OUTPUT_CONFIG_FILE  
echo >> $OUTPUT_CONFIG_FILE
echo "     # Waiting for finish ping test" >> $OUTPUT_CONFIG_FILE
echo "     sleep 15" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "     status=0" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "     WAN1=0" >> $OUTPUT_CONFIG_FILE
echo "     WAN2=0" >> $OUTPUT_CONFIG_FILE
echo "     WAN3=0" >> $OUTPUT_CONFIG_FILE
echo "     WAN4=0" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "     ppp101=\`cat /tmp/testpingwan1.txt\`" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "     if [ -n \"\$ppp101\" ]; then" >> $OUTPUT_CONFIG_FILE
echo "          # echo \"ppp101 is up\"" >> $OUTPUT_CONFIG_FILE
echo "          WAN1=1" >> $OUTPUT_CONFIG_FILE
echo "          status=\`expr \$status + 1\`" >> $OUTPUT_CONFIG_FILE
echo "     fi" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "     ppp102=\`cat /tmp/testpingwan2.txt\`" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE   
echo "     if [ -n \"\$ppp102\" ]; then" >> $OUTPUT_CONFIG_FILE
echo "          # echo \"ppp102 is up\"" >> $OUTPUT_CONFIG_FILE
echo "          WAN2=1" >> $OUTPUT_CONFIG_FILE
echo "          status=\`expr \$status + 2\`" >> $OUTPUT_CONFIG_FILE
echo "     fi" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "     ppp103=\`cat /tmp/testpingwan3.txt\`" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE   
echo "     if [ -n \"\$ppp103\" ]; then" >> $OUTPUT_CONFIG_FILE
echo "          # echo \"ppp103 is up\"" >> $OUTPUT_CONFIG_FILE
echo "          WAN3=1" >> $OUTPUT_CONFIG_FILE
echo "          status=\`expr \$status + 4\`" >> $OUTPUT_CONFIG_FILE
echo "     fi" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "     ppp104=\`cat /tmp/testpingwan4.txt\`" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE   
echo "     if [ -n \"\$ppp104\" ]; then" >> $OUTPUT_CONFIG_FILE
echo "          # echo \"ppp104 is up\"" >> $OUTPUT_CONFIG_FILE
echo "          WAN4=1" >> $OUTPUT_CONFIG_FILE
echo "          status=\`expr \$status + 8\`" >> $OUTPUT_CONFIG_FILE
echo "     fi" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "     #echo Link Status = \$WAN1 \$WAN2 \$WAN3 \$WAN4" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "     LINK_STATUS=\$WAN1\$WAN2\$WAN3\$WAN4" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "     if [ \$status != \$oldstatus ]; then" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "           /etc/init.d/0route.sh \$LINK_STATUS" >> $OUTPUT_CONFIG_FILE
echo "           /etc/init.d/tablenat.sh" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "     fi" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "     oldstatus=\$status" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "done" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE

chmod +x $OUTPUT_CONFIG_FILE

echo "Make /etc/init.d/checklink.sh    ..done."
