#!/bin/bash

OUTPUT_CONFIG_FILE=/etc/init.d/dota.sh

LAN_IP_ADDRESS=`cat config.ini | grep -i LAN_IP_ADDRESS | cut -d "=" -f 2 | awk {'print $1'}`
LAN_NETMASK=`cat config.ini | grep -i LAN_NETMASK | cut -d "=" -f 2 | awk {'print $1'}`
DOTA_START_IP=`cat config.ini | grep -i DOTA_START_IP | cut -d "=" -f 2 | awk {'print $1'}`
DOTA_START_PORT=`cat config.ini | grep -i DOTA_START_PORT | cut -d "=" -f 2 | awk {'print $1'}`
DOTA_CLIENT_COUNT=`cat config.ini | grep -i DOTA_CLIENT_COUNT | cut -d "=" -f 2 | awk {'print $1'}`
LAN_NETWORK=`ipcalc $LAN_IP_ADDRESS/$LAN_NETMASK | grep Network | awk {'print $2'}`
LAN_NETWORK2=`ipcalc $LAN_IP_ADDRESS/$LAN_NETMASK | grep Network | awk {'print $2'} | cut -d "." -f 1-3`

### Config DOTA File ###
echo "#!/bin/bash" > $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "# This file is auto generate by xxxkung script" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE

WAN1_TYPE=`cat config.ini | grep -i WAN1_TYPE | cut -d "=" -f 2 | awk {'print $1'}`
WAN2_TYPE=`cat config.ini | grep -i WAN2_TYPE | cut -d "=" -f 2 | awk {'print $1'}`
WAN3_TYPE=`cat config.ini | grep -i WAN3_TYPE | cut -d "=" -f 2 | awk {'print $1'}`
WAN4_TYPE=`cat config.ini | grep -i WAN4_TYPE | cut -d "=" -f 2 | awk {'print $1'}`

if [ "$WAN1_TYPE" == "pppoe" ]; then
     echo "WAN1IP=\`ip route show | grep ppp101 | awk {'print \$9'}\`" >> $OUTPUT_CONFIG_FILE
fi

if [ "$WAN1_TYPE" == "static" ]; then
     WAN1_STATIC_IP_ADDRESS=`cat config.ini | grep -i WAN1_STATIC_IP_ADDRESS | cut -d "=" -f 2 | awk {'print $1'}`
     echo "WAN1IP=$WAN1_STATIC_IP_ADDRESS" >> $OUTPUT_CONFIG_FILE
fi

if [ "$WAN2_TYPE" == "pppoe" ]; then
     echo "WAN2IP=\`ip route show | grep ppp102 | awk {'print \$9'}\`" >> $OUTPUT_CONFIG_FILE
fi

if [ "$WAN2_TYPE" == "static" ]; then
     WAN2_STATIC_IP_ADDRESS=`cat config.ini | grep -i WAN2_STATIC_IP_ADDRESS | cut -d "=" -f 2 | awk {'print $1'}`
     echo "WAN2IP=$WAN2_STATIC_IP_ADDRESS" >> $OUTPUT_CONFIG_FILE
fi

if [ "$WAN3_TYPE" == "pppoe" ]; then
     echo "WAN3IP=\`ip route show | grep ppp103 | awk {'print \$9'}\`" >> $OUTPUT_CONFIG_FILE
fi

if [ "$WAN3_TYPE" == "static" ]; then
     WAN3_STATIC_IP_ADDRESS=`cat config.ini | grep -i WAN3_STATIC_IP_ADDRESS | cut -d "=" -f 2 | awk {'print $1'}`
     echo "WAN3IP=$WAN3_STATIC_IP_ADDRESS" >> $OUTPUT_CONFIG_FILE
fi

if [ "$WAN4_TYPE" == "pppoe" ]; then
     echo "WAN4IP=\`ip route show | grep ppp104 | awk {'print \$9'}\`" >> $OUTPUT_CONFIG_FILE
fi

if [ "$WAN4_TYPE" == "static" ]; then
     WAN4_STATIC_IP_ADDRESS=`cat config.ini | grep -i WAN4_STATIC_IP_ADDRESS | cut -d "=" -f 2 | awk {'print $1'}`
     echo "WAN4IP=$WAN4_STATIC_IP_ADDRESS" >> $OUTPUT_CONFIG_FILE
fi

echo >> $OUTPUT_CONFIG_FILE
echo "STARTPORT=$DOTA_START_PORT" >> $OUTPUT_CONFIG_FILE
echo "STARTIP=$DOTA_START_IP" >> $OUTPUT_CONFIG_FILE
echo "LANIP=\"$LAN_NETWORK2.\"" >> $OUTPUT_CONFIG_FILE
echo "LANNETWORK=\"$LAN_NETWORK\"" >> $OUTPUT_CONFIG_FILE
echo "SERVERIP=\"$LAN_IP_ADDRESS\"" >> $OUTPUT_CONFIG_FILE
echo "CLIENT=$DOTA_CLIENT_COUNT" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "i=\$STARTPORT" >> $OUTPUT_CONFIG_FILE
echo "j=\`expr \$STARTPORT + \$CLIENT - 1\`" >> $OUTPUT_CONFIG_FILE
echo "k=\$STARTIP" >> $OUTPUT_CONFIG_FILE
echo "while [ \$i -le \$j ]" >> $OUTPUT_CONFIG_FILE
echo "do" >> $OUTPUT_CONFIG_FILE
echo "     if [ -n \"\$WAN1IP\" ]; then" >> $OUTPUT_CONFIG_FILE
echo "          iptables -A PREROUTING -t nat -p tcp -d \$WAN1IP --dport \$i -j DNAT --to \$LANIP\$k:\$i" >> $OUTPUT_CONFIG_FILE
echo "     fi" >> $OUTPUT_CONFIG_FILE
echo "     if [ -n \"\$WAN2IP\" ]; then" >> $OUTPUT_CONFIG_FILE
echo "          iptables -A PREROUTING -t nat -p tcp -d \$WAN2IP --dport \$i -j DNAT --to \$LANIP\$k:\$i" >> $OUTPUT_CONFIG_FILE
echo "     fi" >> $OUTPUT_CONFIG_FILE
echo "     if [ -n \"\$WAN3IP\" ]; then" >> $OUTPUT_CONFIG_FILE
echo "          iptables -A PREROUTING -t nat -p tcp -d \$WAN3IP --dport \$i -j DNAT --to \$LANIP\$k:\$i" >> $OUTPUT_CONFIG_FILE
echo "     fi" >> $OUTPUT_CONFIG_FILE
echo "     if [ -n \"\$WAN4IP\" ]; then" >> $OUTPUT_CONFIG_FILE
echo "          iptables -A PREROUTING -t nat -p tcp -d \$WAN4IP --dport \$i -j DNAT --to \$LANIP\$k:\$i" >> $OUTPUT_CONFIG_FILE
echo "     fi" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "     iptables -A POSTROUTING -t nat -p tcp -s \$LANNETWORK -d \$LANIP\$k --dport \$i -j SNAT --to \$SERVERIP" >> $OUTPUT_CONFIG_FILE
echo "     k=\`expr \$k + 1\`" >> $OUTPUT_CONFIG_FILE
echo "     i=\`expr \$i + 1\`" >> $OUTPUT_CONFIG_FILE
echo "done" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
FWD_IP1=`cat config.ini | grep -i FWD_IP1 | cut -d "=" -f 2 | awk {'print $1'}`
FWD_PORT1=`cat config.ini | grep -i FWD_PORT1 | cut -d "=" -f 2 | awk {'print $1'}`

if [ -n "$FWD_IP1" ]; then
if [ -n "$FWD_PORT1" ]; then
echo "i=$FWD_PORT1" >> $OUTPUT_CONFIG_FILE
echo "k=$FWD_IP1" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "if [ -n \"\$WAN1IP\" ]; then" >> $OUTPUT_CONFIG_FILE
echo "     iptables -A PREROUTING -t nat -p tcp -d \$WAN1IP --dport \$i -j DNAT --to \$LANIP\$k:\$i" >> $OUTPUT_CONFIG_FILE
echo "fi" >> $OUTPUT_CONFIG_FILE
echo "if [ -n \"\$WAN2IP\" ]; then" >> $OUTPUT_CONFIG_FILE
echo "     iptables -A PREROUTING -t nat -p tcp -d \$WAN2IP --dport \$i -j DNAT --to \$LANIP\$k:\$i" >> $OUTPUT_CONFIG_FILE
echo "fi" >> $OUTPUT_CONFIG_FILE
echo "if [ -n \"\$WAN3IP\" ]; then" >> $OUTPUT_CONFIG_FILE
echo "     iptables -A PREROUTING -t nat -p tcp -d \$WAN3IP --dport \$i -j DNAT --to \$LANIP\$k:\$i" >> $OUTPUT_CONFIG_FILE
echo "fi" >> $OUTPUT_CONFIG_FILE
echo "if [ -n \"\$WAN4IP\" ]; then" >> $OUTPUT_CONFIG_FILE
echo "     iptables -A PREROUTING -t nat -p tcp -d \$WAN4IP --dport \$i -j DNAT --to \$LANIP\$k:\$i" >> $OUTPUT_CONFIG_FILE
echo "fi" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
fi
fi

FWD_IP2=`cat config.ini | grep -i FWD_IP2 | cut -d "=" -f 2 | awk {'print $1'}`
FWD_PORT2=`cat config.ini | grep -i FWD_PORT2 | cut -d "=" -f 2 | awk {'print $1'}`

if [ -n "$FWD_IP2" ]; then
if [ -n "$FWD_PORT2" ]; then
echo "i=$FWD_PORT2" >> $OUTPUT_CONFIG_FILE
echo "k=$FWD_IP2" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "if [ -n \"\$WAN1IP\" ]; then" >> $OUTPUT_CONFIG_FILE
echo "     iptables -A PREROUTING -t nat -p tcp -d \$WAN1IP --dport \$i -j DNAT --to \$LANIP\$k:\$i" >> $OUTPUT_CONFIG_FILE
echo "fi" >> $OUTPUT_CONFIG_FILE    
echo "if [ -n \"\$WAN2IP\" ]; then" >> $OUTPUT_CONFIG_FILE
echo "     iptables -A PREROUTING -t nat -p tcp -d \$WAN2IP --dport \$i -j DNAT --to \$LANIP\$k:\$i" >> $OUTPUT_CONFIG_FILE
echo "fi" >> $OUTPUT_CONFIG_FILE
echo "if [ -n \"\$WAN3IP\" ]; then" >> $OUTPUT_CONFIG_FILE
echo "     iptables -A PREROUTING -t nat -p tcp -d \$WAN3IP --dport \$i -j DNAT --to \$LANIP\$k:\$i" >> $OUTPUT_CONFIG_FILE
echo "fi" >> $OUTPUT_CONFIG_FILE
echo "if [ -n \"\$WAN4IP\" ]; then" >> $OUTPUT_CONFIG_FILE
echo "     iptables -A PREROUTING -t nat -p tcp -d \$WAN4IP --dport \$i -j DNAT --to \$LANIP\$k:\$i" >> $OUTPUT_CONFIG_FILE
echo "fi" >> $OUTPUT_CONFIG_FILE    
echo >> $OUTPUT_CONFIG_FILE
fi
fi

FWD_IP3=`cat config.ini | grep -i FWD_IP3 | cut -d "=" -f 2 | awk {'print $1'}`
FWD_PORT3=`cat config.ini | grep -i FWD_PORT3 | cut -d "=" -f 2 | awk {'print $1'}`

if [ -n "$FWD_IP3" ]; then
if [ -n "$FWD_PORT3" ]; then
echo "i=$FWD_PORT3" >> $OUTPUT_CONFIG_FILE
echo "k=$FWD_IP3" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "if [ -n \"\$WAN1IP\" ]; then" >> $OUTPUT_CONFIG_FILE
echo "     iptables -A PREROUTING -t nat -p tcp -d \$WAN1IP --dport \$i -j DNAT --to \$LANIP\$k:\$i" >> $OUTPUT_CONFIG_FILE
echo "fi" >> $OUTPUT_CONFIG_FILE    
echo "if [ -n \"\$WAN2IP\" ]; then" >> $OUTPUT_CONFIG_FILE
echo "     iptables -A PREROUTING -t nat -p tcp -d \$WAN2IP --dport \$i -j DNAT --to \$LANIP\$k:\$i" >> $OUTPUT_CONFIG_FILE
echo "fi" >> $OUTPUT_CONFIG_FILE
echo "if [ -n \"\$WAN3IP\" ]; then" >> $OUTPUT_CONFIG_FILE
echo "     iptables -A PREROUTING -t nat -p tcp -d \$WAN3IP --dport \$i -j DNAT --to \$LANIP\$k:\$i" >> $OUTPUT_CONFIG_FILE
echo "fi" >> $OUTPUT_CONFIG_FILE
echo "if [ -n \"\$WAN4IP\" ]; then" >> $OUTPUT_CONFIG_FILE
echo "     iptables -A PREROUTING -t nat -p tcp -d \$WAN4IP --dport \$i -j DNAT --to \$LANIP\$k:\$i" >> $OUTPUT_CONFIG_FILE
echo "fi" >> $OUTPUT_CONFIG_FILE    
echo >> $OUTPUT_CONFIG_FILE
fi
fi

chmod +x $OUTPUT_CONFIG_FILE

echo "Make /etc/init.d/dota.sh         ..done."
