#!/bin/bash

OUTPUT_CONFIG_FILE=/etc/init.d/tablenat.sh

LAN_INTERFACE=`cat config.ini | grep -i LAN_INTERFACE | cut -d "=" -f 2 | awk {'print $1'}`
WAN1_TYPE=`cat config.ini | grep -i WAN1_TYPE | cut -d "=" -f 2 | awk {'print $1'}`
WAN2_TYPE=`cat config.ini | grep -i WAN2_TYPE | cut -d "=" -f 2 | awk {'print $1'}`
WAN3_TYPE=`cat config.ini | grep -i WAN3_TYPE | cut -d "=" -f 2 | awk {'print $1'}`
WAN4_TYPE=`cat config.ini | grep -i WAN4_TYPE | cut -d "=" -f 2 | awk {'print $1'}`

### Config tablenat.sh File ###
echo "#!/bin/bash" > $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "# This file is auto generate by xxxkung script" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "# Flush table nat" >> $OUTPUT_CONFIG_FILE
echo "iptables -t nat -F" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "# MASQUERADE" >> $OUTPUT_CONFIG_FILE
echo "iptables -t nat -A POSTROUTING -o ppp+ -j MASQUERADE" >> $OUTPUT_CONFIG_FILE

if [ "$WAN1_TYPE" == "static" ]; then
     WAN1_INTERFACE=`cat config.ini | grep -i WAN1_INTERFACE | cut -d "=" -f 2 | awk {'print $1'}`
     echo "iptables -t nat -A POSTROUTING -o $WAN1_INTERFACE -j MASQUERADE" >> $OUTPUT_CONFIG_FILE
fi

if [ "$WAN2_TYPE" == "static" ]; then
     WAN2_INTERFACE=`cat config.ini | grep -i WAN2_INTERFACE | cut -d "=" -f 2 | awk {'print $1'}`
     echo "iptables -t nat -A POSTROUTING -o $WAN2_INTERFACE -j MASQUERADE" >> $OUTPUT_CONFIG_FILE
fi

if [ "$WAN3_TYPE" == "static" ]; then
     WAN3_INTERFACE=`cat config.ini | grep -i WAN3_INTERFACE | cut -d "=" -f 2 | awk {'print $1'}`
     echo "iptables -t nat -A POSTROUTING -o $WAN3_INTERFACE -j MASQUERADE" >> $OUTPUT_CONFIG_FILE
fi

if [ "$WAN4_TYPE" == "static" ]; then
     WAN4_INTERFACE=`cat config.ini | grep -i WAN4_INTERFACE | cut -d "=" -f 2 | awk {'print $1'}`
     echo "iptables -t nat -A POSTROUTING -o $WAN4_INTERFACE -j MASQUERADE" >> $OUTPUT_CONFIG_FILE
fi

echo >> $OUTPUT_CONFIG_FILE
echo "# DOTA" >> $OUTPUT_CONFIG_FILE
echo "/etc/init.d/dota.sh" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "# TPROXY" >> $OUTPUT_CONFIG_FILE
echo "iptables -t nat -X TPROXY" >> $OUTPUT_CONFIG_FILE
echo "iptables -t nat -N TPROXY" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "iptables -t nat -A PREROUTING -i $LAN_INTERFACE -p tcp -s 0/0 -d 0/0 -m multiport --dport 80,5977,9898 -j TPROXY" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "/etc/init.d/tproxy.sh" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "# FROX" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "iptables -t nat -X FROX" >> $OUTPUT_CONFIG_FILE
echo "iptables -t nat -N FROX" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "iptables -t nat -A PREROUTING -i $LAN_INTERFACE -p tcp -s 0/0 -d 0/0 -m multiport --dport 21,8021 -j FROX" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "/etc/init.d/frox.sh" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "echo \"   ...done.\"" >> $OUTPUT_CONFIG_FILE

chmod +x $OUTPUT_CONFIG_FILE

echo "Make /etc/init.d/tablenat.sh     ..done."
