#!/bin/bash

OUTPUT_CONFIG_FILE=/etc/init.d/tableroute.sh

LAN_INTERFACE=`cat config.ini | grep -i LAN_INTERFACE | cut -d "=" -f 2 | awk {'print $1'}`
LAN_IP_ADDRESS=`cat config.ini | grep -i LAN_IP_ADDRESS | cut -d "=" -f 2 | awk {'print $1'}`
LAN_NETMASK=`cat config.ini | grep -i LAN_NETMASK | cut -d "=" -f 2 | awk {'print $1'}`
LAN_NETWORK=`ipcalc $LAN_IP_ADDRESS/$LAN_NETMASK | grep Network | awk {'print $2'}`
WAN1_TYPE=`cat config.ini | grep -i WAN1_TYPE | cut -d "=" -f 2 | awk {'print $1'}`
WAN2_TYPE=`cat config.ini | grep -i WAN2_TYPE | cut -d "=" -f 2 | awk {'print $1'}`
WAN3_TYPE=`cat config.ini | grep -i WAN3_TYPE | cut -d "=" -f 2 | awk {'print $1'}`
WAN4_TYPE=`cat config.ini | grep -i WAN4_TYPE | cut -d "=" -f 2 | awk {'print $1'}`

### Config tableroute.sh File ###
echo "#!/bin/bash" > $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "# This file is auto generate by xxxkung script" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "modprobe ip_nat_ftp" >> $OUTPUT_CONFIG_FILE        
echo "modprobe ip_tables" >> $OUTPUT_CONFIG_FILE
echo "modprobe iptable_nat" >> $OUTPUT_CONFIG_FILE
echo "modprobe ipt_conntrack" >> $OUTPUT_CONFIG_FILE
echo "modprobe ip_conntrack" >> $OUTPUT_CONFIG_FILE
echo "modprobe ip_conntrack_ftp" >> $OUTPUT_CONFIG_FILE
echo "modprobe ip_conntrack_irc" >> $OUTPUT_CONFIG_FILE
echo "modprobe ip_nat_irc" >> $OUTPUT_CONFIG_FILE
echo "modprobe ip_nat_snmp_basic" >> $OUTPUT_CONFIG_FILE

echo >> $OUTPUT_CONFIG_FILE
echo "# FLUSH ALL USE CHAIN" >> $OUTPUT_CONFIG_FILE
echo "iptables -t mangle -F" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "# MARK FOR ADSL PPPoE #" >> $OUTPUT_CONFIG_FILE
echo "iptables -t mangle -o ppp101 --insert FORWARD 1 -p tcp --tcp-flags SYN,RST SYN -m tcpmss --mss 1400:1536 -j TCPMSS --clamp-mss-to-pmtu" >> $OUTPUT_CONFIG_FILE
echo "iptables -t mangle -o ppp102 --insert FORWARD 1 -p tcp --tcp-flags SYN,RST SYN -m tcpmss --mss 1400:1536 -j TCPMSS --clamp-mss-to-pmtu" >> $OUTPUT_CONFIG_FILE
echo "iptables -t mangle -o ppp103 --insert FORWARD 1 -p tcp --tcp-flags SYN,RST SYN -m tcpmss --mss 1400:1536 -j TCPMSS --clamp-mss-to-pmtu" >> $OUTPUT_CONFIG_FILE
echo "iptables -t mangle -o ppp104 --insert FORWARD 1 -p tcp --tcp-flags SYN,RST SYN -m tcpmss --mss 1400:1536 -j TCPMSS --clamp-mss-to-pmtu" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "# DELETE OLD CHAIN" >> $OUTPUT_CONFIG_FILE
echo "iptables -t mangle -X MARK_RULES" >> $OUTPUT_CONFIG_FILE
echo "iptables -t mangle -X GAMES_GROUP1" >> $OUTPUT_CONFIG_FILE
echo "iptables -t mangle -X GAMES_GROUP2" >> $OUTPUT_CONFIG_FILE
echo "iptables -t mangle -X GAMES_GROUP3" >> $OUTPUT_CONFIG_FILE
echo "iptables -t mangle -X WEB_LINK" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "# CREATE NEW CHAIN" >> $OUTPUT_CONFIG_FILE
echo "iptables -t mangle -N MARK_RULES" >> $OUTPUT_CONFIG_FILE
echo "iptables -t mangle -N GAMES_GROUP1" >> $OUTPUT_CONFIG_FILE
echo "iptables -t mangle -N GAMES_GROUP2" >> $OUTPUT_CONFIG_FILE
echo "iptables -t mangle -N GAMES_GROUP3" >> $OUTPUT_CONFIG_FILE
echo "iptables -t mangle -N WEB_LINK" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "# MARK RULE FOR NEW PACKET" >> $OUTPUT_CONFIG_FILE
echo "iptables -t mangle -A PREROUTING -i $LAN_INTERFACE -m state --state NEW -j MARK_RULES" >> $OUTPUT_CONFIG_FILE
echo "iptables -t mangle -A PREROUTING -i $LAN_INTERFACE -m state --state RELATED,ESTABLISHED -j CONNMARK --restore-mark" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "/etc/init.d/markrules.sh" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "# MARK PACKET LINK" >> $OUTPUT_CONFIG_FILE
echo "iptables -t mangle -A GAMES_GROUP1 -j MARK --set-mark 0x10" >> $OUTPUT_CONFIG_FILE
echo "iptables -t mangle -A GAMES_GROUP2 -j MARK --set-mark 0x20" >> $OUTPUT_CONFIG_FILE
echo "iptables -t mangle -A GAMES_GROUP3 -j MARK --set-mark 0x30" >> $OUTPUT_CONFIG_FILE
echo "iptables -t mangle -A WEB_LINK -j MARK --set-mark 0x40" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "# MARK INPUT PACKET" >> $OUTPUT_CONFIG_FILE

if [ "$WAN1_TYPE" == "pppoe" ]; then
     echo "iptables -t mangle -A PREROUTING -i ppp101 -j CONNMARK --set-mark 0x101" >> $OUTPUT_CONFIG_FILE
fi

if [ "$WAN1_TYPE" == "static" ]; then
     WAN1_INTERFACE=`cat config.ini | grep -i WAN1_INTERFACE | cut -d "=" -f 2 | awk {'print $1'}`
     echo "iptables -t mangle -A PREROUTING -i $WAN1_INTERFACE -j CONNMARK --set-mark 0x101" >> $OUTPUT_CONFIG_FILE
fi

if [ "$WAN2_TYPE" == "pppoe" ]; then 
     echo "iptables -t mangle -A PREROUTING -i ppp102 -j CONNMARK --set-mark 0x102" >> $OUTPUT_CONFIG_FILE
fi

if [ "$WAN2_TYPE" == "static" ]; then
     WAN2_INTERFACE=`cat config.ini | grep -i WAN2_INTERFACE | cut -d "=" -f 2 | awk {'print $1'}`
     echo "iptables -t mangle -A PREROUTING -i $WAN2_INTERFACE -j CONNMARK --set-mark 0x102" >> $OUTPUT_CONFIG_FILE
fi

if [ "$WAN3_TYPE" == "pppoe" ]; then 
     echo "iptables -t mangle -A PREROUTING -i ppp103 -j CONNMARK --set-mark 0x103" >> $OUTPUT_CONFIG_FILE
fi

if [ "$WAN3_TYPE" == "static" ]; then
     WAN3_INTERFACE=`cat config.ini | grep -i WAN3_INTERFACE | cut -d "=" -f 2 | awk {'print $1'}`
     echo "iptables -t mangle -A PREROUTING -i $WAN3_INTERFACE -j CONNMARK --set-mark 0x103" >> $OUTPUT_CONFIG_FILE
fi

if [ "$WAN4_TYPE" == "pppoe" ]; then 
     echo "iptables -t mangle -A PREROUTING -i ppp104 -j CONNMARK --set-mark 0x104" >> $OUTPUT_CONFIG_FILE
fi

if [ "$WAN4_TYPE" == "static" ]; then
     WAN4_INTERFACE=`cat config.ini | grep -i WAN4_INTERFACE | cut -d "=" -f 2 | awk {'print $1'}`
     echo "iptables -t mangle -A PREROUTING -i $WAN4_INTERFACE -j CONNMARK --set-mark 0x104" >> $OUTPUT_CONFIG_FILE
fi

echo >> $OUTPUT_CONFIG_FILE
echo "# MARK OUTPUT PACKET" >> $OUTPUT_CONFIG_FILE

if [ "$WAN1_TYPE" == "pppoe" ]; then
     echo "iptables -t mangle -A POSTROUTING -o ppp101 -j CONNMARK --set-mark 0x101" >> $OUTPUT_CONFIG_FILE
fi

if [ "$WAN1_TYPE" == "static" ]; then
     WAN1_INTERFACE=`cat config.ini | grep -i WAN1_INTERFACE | cut -d "=" -f 2 | awk {'print $1'}`
     echo "iptables -t mangle -A POSTROUTING -o $WAN1_INTERFACE -j CONNMARK --set-mark 0x101" >> $OUTPUT_CONFIG_FILE
fi

if [ "$WAN2_TYPE" == "pppoe" ]; then
     echo "iptables -t mangle -A POSTROUTING -o ppp102 -j CONNMARK --set-mark 0x102" >> $OUTPUT_CONFIG_FILE
fi

if [ "$WAN2_TYPE" == "static" ]; then
     WAN2_INTERFACE=`cat config.ini | grep -i WAN2_INTERFACE | cut -d "=" -f 2 | awk {'print $1'}`
     echo "iptables -t mangle -A POSTROUTING -o $WAN2_INTERFACE -j CONNMARK --set-mark 0x102" >> $OUTPUT_CONFIG_FILE
fi

if [ "$WAN3_TYPE" == "pppoe" ]; then
     echo "iptables -t mangle -A POSTROUTING -o ppp103 -j CONNMARK --set-mark 0x103" >> $OUTPUT_CONFIG_FILE
fi

if [ "$WAN3_TYPE" == "static" ]; then
     WAN3_INTERFACE=`cat config.ini | grep -i WAN3_INTERFACE | cut -d "=" -f 2 | awk {'print $1'}`
     echo "iptables -t mangle -A POSTROUTING -o $WAN3_INTERFACE -j CONNMARK --set-mark 0x103" >> $OUTPUT_CONFIG_FILE
fi

if [ "$WAN4_TYPE" == "pppoe" ]; then
     echo "iptables -t mangle -A POSTROUTING -o ppp104 -j CONNMARK --set-mark 0x104" >> $OUTPUT_CONFIG_FILE
fi

if [ "$WAN4_TYPE" == "static" ]; then
     WAN4_INTERFACE=`cat config.ini | grep -i WAN4_INTERFACE | cut -d "=" -f 2 | awk {'print $1'}`
     echo "iptables -t mangle -A POSTROUTING -o $WAN4_INTERFACE -j CONNMARK --set-mark 0x104" >> $OUTPUT_CONFIG_FILE
fi

echo >> $OUTPUT_CONFIG_FILE
echo "XT=\"10 20 30 40 101 102 103 104\"" >> $OUTPUT_CONFIG_FILE
echo "for i in \$XT; do" >> $OUTPUT_CONFIG_FILE
echo "ip route flush table \$i" >> $OUTPUT_CONFIG_FILE
echo "done" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "for i in \$XT; do" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "     ip route add table \$i $LAN_NETWORK dev $LAN_INTERFACE  proto kernel  scope link  src $LAN_IP_ADDRESS" >> $OUTPUT_CONFIG_FILE
echo "     ip rule del table \$i prio \$i" >> $OUTPUT_CONFIG_FILE
echo "     ip rule add fwmark 0x\$i table \$i prio \$i" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "done" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE

if [ "$WAN1_TYPE" == "static" ]; then
     WAN1_INTERFACE=`cat config.ini | grep -i WAN1_INTERFACE | cut -d "=" -f 2 | awk {'print $1'}`
     WAN1_STATIC_IP_ADDRESS=`cat config.ini | grep -i WAN1_STATIC_IP_ADDRESS | cut -d "=" -f 2 | awk {'print $1'}`
     WAN1_STATIC_NETMASK=`cat config.ini | grep -i WAN1_STATIC_NETMASK | cut -d "=" -f 2 | awk {'print $1'}`
     WAN1_STATIC_GATEWAY=`cat config.ini | grep -i WAN1_STATIC_GATEWAY | cut -d "=" -f 2 | awk {'print $1'}`
     WAN1_NETWORK=`ipcalc $WAN1_STATIC_IP_ADDRESS $WAN1_STATIC_NETMASK | grep Network | awk {'print $2'}`
     echo "ip route add table 101 $WAN1_NETWORK dev $WAN1_INTERFACE proto kernel scope link src $WAN1_STATIC_IP_ADDRESS" >> $OUTPUT_CONFIG_FILE
     echo "ip route add table 101 default via $WAN1_STATIC_GATEWAY dev $WAN1_INTERFACE" >> $OUTPUT_CONFIG_FILE
     echo "ip rule add from $WAN1_NETWORK lookup 101 prio 201" >> $OUTPUT_CONFIG_FILE
fi

if [ "$WAN2_TYPE" == "static" ]; then
     WAN2_INTERFACE=`cat config.ini | grep -i WAN2_INTERFACE | cut -d "=" -f 2 | awk {'print $1'}`
     WAN2_STATIC_IP_ADDRESS=`cat config.ini | grep -i WAN2_STATIC_IP_ADDRESS | cut -d "=" -f 2 | awk {'print $1'}`
     WAN2_STATIC_NETMASK=`cat config.ini | grep -i WAN2_STATIC_NETMASK | cut -d "=" -f 2 | awk {'print $1'}`
     WAN2_STATIC_GATEWAY=`cat config.ini | grep -i WAN2_STATIC_GATEWAY | cut -d "=" -f 2 | awk {'print $1'}`
     WAN2_NETWORK=`ipcalc $WAN2_STATIC_IP_ADDRESS $WAN2_STATIC_NETMASK | grep Network | awk {'print $2'}`
     echo "ip route add table 102 $WAN2_NETWORK dev $WAN2_INTERFACE proto kernel scope link src $WAN2_STATIC_IP_ADDRESS" >> $OUTPUT_CONFIG_FILE
     echo "ip route add table 102 default via $WAN2_STATIC_GATEWAY dev $WAN2_INTERFACE" >> $OUTPUT_CONFIG_FILE
     echo "ip rule add from $WAN2_NETWORK lookup 102 prio 202" >> $OUTPUT_CONFIG_FILE
fi

if [ "$WAN3_TYPE" == "static" ]; then
     WAN3_INTERFACE=`cat config.ini | grep -i WAN3_INTERFACE | cut -d "=" -f 2 | awk {'print $1'}`
     WAN3_STATIC_IP_ADDRESS=`cat config.ini | grep -i WAN3_STATIC_IP_ADDRESS | cut -d "=" -f 2 | awk {'print $1'}`
     WAN3_STATIC_NETMASK=`cat config.ini | grep -i WAN3_STATIC_NETMASK | cut -d "=" -f 2 | awk {'print $1'}`
     WAN3_STATIC_GATEWAY=`cat config.ini | grep -i WAN3_STATIC_GATEWAY | cut -d "=" -f 2 | awk {'print $1'}`
     WAN3_NETWORK=`ipcalc $WAN3_STATIC_IP_ADDRESS $WAN3_STATIC_NETMASK | grep Network | awk {'print $2'}`
     echo "ip route add table 103 $WAN3_NETWORK dev $WAN3_INTERFACE proto kernel scope link src $WAN3_STATIC_IP_ADDRESS" >> $OUTPUT_CONFIG_FILE
     echo "ip route add table 103 default via $WAN3_STATIC_GATEWAY dev $WAN3_INTERFACE" >> $OUTPUT_CONFIG_FILE
     echo "ip rule add from $WAN3_NETWORK lookup 103 prio 203" >> $OUTPUT_CONFIG_FILE
fi

if [ "$WAN4_TYPE" == "static" ]; then
     WAN4_INTERFACE=`cat config.ini | grep -i WAN4_INTERFACE | cut -d "=" -f 2 | awk {'print $1'}`
     WAN4_STATIC_IP_ADDRESS=`cat config.ini | grep -i WAN4_STATIC_IP_ADDRESS | cut -d "=" -f 2 | awk {'print $1'}`
     WAN4_STATIC_NETMASK=`cat config.ini | grep -i WAN4_STATIC_NETMASK | cut -d "=" -f 2 | awk {'print $1'}`
     WAN4_STATIC_GATEWAY=`cat config.ini | grep -i WAN4_STATIC_GATEWAY | cut -d "=" -f 2 | awk {'print $1'}`
     WAN4_NETWORK=`ipcalc $WAN4_STATIC_IP_ADDRESS $WAN4_STATIC_NETMASK | grep Network | awk {'print $2'}`
     echo "ip route add table 104 $WAN4_NETWORK dev $WAN4_INTERFACE proto kernel scope link src $WAN4_STATIC_IP_ADDRESS" >> $OUTPUT_CONFIG_FILE
     echo "ip route add table 104 default via $WAN4_STATIC_GATEWAY dev $WAN4_INTERFACE" >> $OUTPUT_CONFIG_FILE
     echo "ip rule add from $WAN4_NETWORK lookup 104 prio 204" >> $OUTPUT_CONFIG_FILE
fi

echo >> $OUTPUT_CONFIG_FILE
echo "/etc/ppp/ip-up.d/0route" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "echo \"   ...done.\"" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE

chmod +x $OUTPUT_CONFIG_FILE

echo "Make /etc/init.d/tableroute.sh   ..done."
