#!/bin/bash

OUTPUT_CONFIG_FILE=/etc/rc.local

### Config Startup Script File ###
echo "#!/bin/bash" > $OUTPUT_CONFIG_FILE

echo >> $OUTPUT_CONFIG_FILE
echo "# This file is auto generate by xxxkung script" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE

echo "# Set VLAN Name Type #" >> $OUTPUT_CONFIG_FILE
echo "vconfig set_name_type VLAN_PLUS_VID_NO_PAD" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE

VLAN101_INTERFACE=`cat config.ini | grep -i VLAN101_INTERFACE | cut -d "=" -f 2 | awk {'print $1'}`
VLAN102_INTERFACE=`cat config.ini | grep -i VLAN102_INTERFACE | cut -d "=" -f 2 | awk {'print $1'}`
VLAN103_INTERFACE=`cat config.ini | grep -i VLAN103_INTERFACE | cut -d "=" -f 2 | awk {'print $1'}`
VLAN104_INTERFACE=`cat config.ini | grep -i VLAN104_INTERFACE | cut -d "=" -f 2 | awk {'print $1'}`

if [ "$VLAN101_INTERFACE" != "" ]; then
     echo "# Set VLAN Interface #" >> $OUTPUT_CONFIG_FILE
     echo "vconfig add $VLAN101_INTERFACE 101" >> $OUTPUT_CONFIG_FILE
     echo "ifconfig vlan101 hw ether 08:00:DE:AD:01:01 up" >> $OUTPUT_CONFIG_FILE
     echo >> $OUTPUT_CONFIG_FILE
fi

if [ "$VLAN102_INTERFACE" != "" ]; then
     echo "# Set VLAN Interface #" >> $OUTPUT_CONFIG_FILE
     echo "vconfig add $VLAN102_INTERFACE 102" >> $OUTPUT_CONFIG_FILE
     echo "ifconfig vlan102 hw ether 08:00:DE:AD:01:02 up" >> $OUTPUT_CONFIG_FILE
     echo >> $OUTPUT_CONFIG_FILE
fi

if [ "$VLAN103_INTERFACE" != "" ]; then
     echo "# Set VLAN Interface #" >> $OUTPUT_CONFIG_FILE
     echo "vconfig add $VLAN103_INTERFACE 103" >> $OUTPUT_CONFIG_FILE
     echo "ifconfig vlan103 hw ether 08:00:DE:AD:01:03 up" >> $OUTPUT_CONFIG_FILE
     echo >> $OUTPUT_CONFIG_FILE
fi

if [ "$VLAN104_INTERFACE" != "" ]; then
     echo "# Set VLAN Interface #" >> $OUTPUT_CONFIG_FILE
     echo "vconfig add $VLAN104_INTERFACE 104" >> $OUTPUT_CONFIG_FILE
     echo "ifconfig vlan104 hw ether 08:00:DE:AD:01:04 up" >> $OUTPUT_CONFIG_FILE
     echo >> $OUTPUT_CONFIG_FILE
fi

echo "# Set Enable IP Forward #" >> $OUTPUT_CONFIG_FILE
echo "echo 1 > /proc/sys/net/ipv4/ip_forward" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE

LAN_INTERFACE=`cat config.ini | grep -i LAN_INTERFACE | cut -d "=" -f 2 | awk {'print $1'}`
LAN_IP_ADDRESS=`cat config.ini | grep -i LAN_IP_ADDRESS | cut -d "=" -f 2 | awk {'print $1'}`
LAN_NETMASK=`cat config.ini | grep -i LAN_NETMASK | cut -d "=" -f 2 | awk {'print $1'}`

echo "# Set LAN Interface #" >> $OUTPUT_CONFIG_FILE
echo "ifconfig $LAN_INTERFACE $LAN_IP_ADDRESS netmask $LAN_NETMASK up" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE

WAN1_TYPE=`cat config.ini | grep -i WAN1_TYPE | cut -d "=" -f 2 | awk {'print $1'}`

echo "# Set WAN1 Interface #" >> $OUTPUT_CONFIG_FILE

if [ "$WAN1_TYPE" == "static" ]; then
     WAN1_INTERFACE=`cat config.ini | grep -i WAN1_INTERFACE | cut -d "=" -f 2 | awk {'print $1'}`
     WAN1_STATIC_IP_ADDRESS=`cat config.ini | grep -i WAN1_STATIC_IP_ADDRESS | cut -d "=" -f 2 | awk {'print $1'}`
     WAN1_STATIC_NETMASK=`cat config.ini | grep -i WAN1_STATIC_NETMASK | cut -d "=" -f 2 | awk {'print $1'}`
     echo "echo 0 > /proc/sys/net/ipv4/conf/$WAN1_INTERFACE/rp_filter" >> $OUTPUT_CONFIG_FILE
     echo "ifconfig $WAN1_INTERFACE $WAN1_STATIC_IP_ADDRESS netmask $WAN1_STATIC_NETMASK up" >> $OUTPUT_CONFIG_FILE
     echo >> $OUTPUT_CONFIG_FILE
fi

if [ "$WAN1_TYPE" == "pppoe" ]; then
     WAN1_INTERFACE=`cat config.ini | grep -i WAN1_INTERFACE | cut -d "=" -f 2 | awk {'print $1'}`
     echo "ifconfig $WAN1_INTERFACE up" >> $OUTPUT_CONFIG_FILE
     echo "sleep 1" >> $OUTPUT_CONFIG_FILE
     echo "pon dsl-link1" >> $OUTPUT_CONFIG_FILE
     echo >> $OUTPUT_CONFIG_FILE
fi

WAN2_TYPE=`cat config.ini | grep -i WAN2_TYPE | cut -d "=" -f 2 | awk {'print $1'}`

echo "# Set WAN2 Interface #" >> $OUTPUT_CONFIG_FILE

if [ "$WAN2_TYPE" == "static" ]; then
     WAN2_INTERFACE=`cat config.ini | grep -i WAN2_INTERFACE | cut -d "=" -f 2 | awk {'print $1'}`
     WAN2_STATIC_IP_ADDRESS=`cat config.ini | grep -i WAN2_STATIC_IP_ADDRESS | cut -d "=" -f 2 | awk {'print $1'}`
     WAN2_STATIC_NETMASK=`cat config.ini | grep -i WAN2_STATIC_NETMASK | cut -d "=" -f 2 | awk {'print $1'}`
     echo "echo 0 > /proc/sys/net/ipv4/conf/$WAN2_INTERFACE/rp_filter" >> $OUTPUT_CONFIG_FILE
     echo "ifconfig $WAN2_INTERFACE $WAN2_STATIC_IP_ADDRESS netmask $WAN2_STATIC_NETMASK up" >> $OUTPUT_CONFIG_FILE
     echo >> $OUTPUT_CONFIG_FILE
fi

if [ "$WAN2_TYPE" == "pppoe" ]; then
     WAN2_INTERFACE=`cat config.ini | grep -i WAN2_INTERFACE | cut -d "=" -f 2 | awk {'print $1'}`
     echo "ifconfig $WAN2_INTERFACE up" >> $OUTPUT_CONFIG_FILE
     echo "sleep 1" >> $OUTPUT_CONFIG_FILE
     echo "pon dsl-link2" >> $OUTPUT_CONFIG_FILE
     echo >> $OUTPUT_CONFIG_FILE
fi

WAN3_TYPE=`cat config.ini | grep -i WAN3_TYPE | cut -d "=" -f 2 | awk {'print $1'}`

echo "# Set WAN3 Interface #" >> $OUTPUT_CONFIG_FILE

if [ "$WAN3_TYPE" == "static" ]; then
     WAN3_INTERFACE=`cat config.ini | grep -i WAN3_INTERFACE | cut -d "=" -f 2 | awk {'print $1'}`
     WAN3_STATIC_IP_ADDRESS=`cat config.ini | grep -i WAN3_STATIC_IP_ADDRESS | cut -d "=" -f 2 | awk {'print $1'}`
     WAN3_STATIC_NETMASK=`cat config.ini | grep -i WAN3_STATIC_NETMASK | cut -d "=" -f 2 | awk {'print $1'}`
     echo "echo 0 > /proc/sys/net/ipv4/conf/$WAN3_INTERFACE/rp_filter" >> $OUTPUT_CONFIG_FILE
     echo "ifconfig $WAN3_INTERFACE $WAN3_STATIC_IP_ADDRESS netmask $WAN3_STATIC_NETMASK up" >> $OUTPUT_CONFIG_FILE
     echo >> $OUTPUT_CONFIG_FILE
fi

if [ "$WAN3_TYPE" == "pppoe" ]; then
     WAN3_INTERFACE=`cat config.ini | grep -i WAN3_INTERFACE | cut -d "=" -f 2 | awk {'print $1'}`
     echo "ifconfig $WAN3_INTERFACE up" >> $OUTPUT_CONFIG_FILE
     echo "sleep 1" >> $OUTPUT_CONFIG_FILE
     echo "pon dsl-link3" >> $OUTPUT_CONFIG_FILE
     echo >> $OUTPUT_CONFIG_FILE
fi

WAN4_TYPE=`cat config.ini | grep -i WAN4_TYPE | cut -d "=" -f 2 | awk {'print $1'}`

echo "# Set WAN4 Interface #" >> $OUTPUT_CONFIG_FILE

if [ "$WAN4_TYPE" == "static" ]; then
     WAN4_INTERFACE=`cat config.ini | grep -i WAN4_INTERFACE | cut -d "=" -f 2 | awk {'print $1'}`
     WAN4_STATIC_IP_ADDRESS=`cat config.ini | grep -i WAN4_STATIC_IP_ADDRESS | cut -d "=" -f 2 | awk {'print $1'}`
     WAN4_STATIC_NETMASK=`cat config.ini | grep -i WAN4_STATIC_NETMASK | cut -d "=" -f 2 | awk {'print $1'}`
     echo "echo 0 > /proc/sys/net/ipv4/conf/$WAN4_INTERFACE/rp_filter" >> $OUTPUT_CONFIG_FILE
     echo "ifconfig $WAN4_INTERFACE $WAN4_STATIC_IP_ADDRESS netmask $WAN4_STATIC_NETMASK up" >> $OUTPUT_CONFIG_FILE
     echo >> $OUTPUT_CONFIG_FILE
fi

if [ "$WAN4_TYPE" == "pppoe" ]; then
     WAN4_INTERFACE=`cat config.ini | grep -i WAN4_INTERFACE | cut -d "=" -f 2 | awk {'print $1'}`
     echo "ifconfig $WAN4_INTERFACE up" >> $OUTPUT_CONFIG_FILE
     echo "sleep 1" >> $OUTPUT_CONFIG_FILE
     echo "pon dsl-link4" >> $OUTPUT_CONFIG_FILE
     echo >> $OUTPUT_CONFIG_FILE
fi

echo >> $OUTPUT_CONFIG_FILE
echo "#Flush All Chain" >> $OUTPUT_CONFIG_FILE
echo "iptables -F" >> $OUTPUT_CONFIG_FILE
echo "iptables -t nat -F" >> $OUTPUT_CONFIG_FILE
echo "iptables -t mangle -F" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "/etc/init.d/noip2 start" >> $OUTPUT_CONFIG_FILE
echo "/etc/init.d/dhcp3-server start" >> $OUTPUT_CONFIG_FILE
echo "/etc/init.d/tablenat.sh" >> $OUTPUT_CONFIG_FILE
echo "/etc/init.d/firewall.sh" >> $OUTPUT_CONFIG_FILE
echo "/etc/init.d/tableroute.sh" >> $OUTPUT_CONFIG_FILE
echo "" >> $OUTPUT_CONFIG_FILE
echo "/etc/init.d/checklink.sh &" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "exit 0" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE

chmod +x $OUTPUT_CONFIG_FILE

echo "Make /etc/rc.local               ..done."
