#!/bin/bash

OUTPUT_CONFIG_FILE=/etc/squid/squid.conf

SERVER_MEM=`cat /proc/meminfo | grep MemTotal | awk {'print $2'}`

SQUID_CACHE_MEM=$(echo $SERVER_MEM / 1000 - 256 | bc)
SQUID_MEM_POOLS=$(echo $SERVER_MEM / 10000 | bc)
SQUID_MAX_OBJ_SIZE=256
SQUID_MAX_OBJ_SIZE_MEM=1024

LAN_IP_ADDRESS=`cat config.ini | grep -i LAN_IP_ADDRESS | cut -d "=" -f 2 | awk {'print $1'}`
SQUID_CACHE_SIZE=`cat config.ini | grep -i SQUID_CACHE_SIZE | cut -d "=" -f 2 | awk {'print $1'}`

### Config SQUID File ###
echo "# This file is auto generate by xxxkung script" > $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "http_port $LAN_IP_ADDRESS:8080 transparent no-connection-auth" >> $OUTPUT_CONFIG_FILE
echo "tcp_outgoing_address 0.0.0.0" >> $OUTPUT_CONFIG_FILE
echo "udp_incoming_address 0.0.0.0" >> $OUTPUT_CONFIG_FILE
echo "udp_outgoing_address 0.0.0.0" >> $OUTPUT_CONFIG_FILE
echo "icp_port 0" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "# Time Out" >> $OUTPUT_CONFIG_FILE
echo "request_timeout 5 minutes" >> $OUTPUT_CONFIG_FILE
echo "forward_timeout 5 minutes" >> $OUTPUT_CONFIG_FILE
echo "connect_timeout 5 minutes" >> $OUTPUT_CONFIG_FILE
echo "peer_connect_timeout 1 minutes" >> $OUTPUT_CONFIG_FILE
echo "pconn_timeout 120 seconds" >> $OUTPUT_CONFIG_FILE
echo "read_timeout 15 minutes" >> $OUTPUT_CONFIG_FILE
echo "request_timeout 5 minutes" >> $OUTPUT_CONFIG_FILE
echo "persistent_request_timeout 2 minute" >> $OUTPUT_CONFIG_FILE
echo "shutdown_lifetime 5 seconds" >> $OUTPUT_CONFIG_FILE
echo "negative_ttl 2 minutes" >> $OUTPUT_CONFIG_FILE
echo "negative_ttl 3 minutes" >> $OUTPUT_CONFIG_FILE
echo "positive_dns_ttl 120 seconds" >> $OUTPUT_CONFIG_FILE
echo "negative_dns_ttl 120 seconds" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "netdb_low 900" >> $OUTPUT_CONFIG_FILE
echo "netdb_high 1000" >> $OUTPUT_CONFIG_FILE
echo "client_db on" >> $OUTPUT_CONFIG_FILE
echo "client_lifetime 1 day" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "# ACL CONTROLS" >> $OUTPUT_CONFIG_FILE
echo "#----------------------------------------" >> $OUTPUT_CONFIG_FILE
echo "acl Manager proto cache_object" >> $OUTPUT_CONFIG_FILE
echo "acl all src 0.0.0.0/0" >> $OUTPUT_CONFIG_FILE
echo "acl localhost src 127.0.0.1/32" >> $OUTPUT_CONFIG_FILE
echo "acl our_networks src 10.0.0.0/8 172.16.0.0/12 192.168.0.0/16" >> $OUTPUT_CONFIG_FILE
echo "acl All_Port port 1-65535" >> $OUTPUT_CONFIG_FILE
echo "acl CONNECT method CONNECT" >> $OUTPUT_CONFIG_FILE
echo "acl blockweb dst 208.73.212.0/24" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "# mark for no cache" >> $OUTPUT_CONFIG_FILE
echo "hierarchy_stoplist cgi-bin ? localhost .asp .aspx .php .inf .dll .Xt .xtp .ini localhost php$ inf$ dll$ Xt$ xtp$ ini$ asp$ aspx$ .exe .cfg ucg" >> $OUTPUT_CONFIG_FILE
echo "acl QUERY urlpath_regex cgi-bin \? localhost .asp .aspx .php .inf .dll .Xt .xtp .ini localhost php$ inf$ dll$ Xt$ xtp$ ini$ asp$ aspx$ updatelist$ patch_S4 .cfg .exe ucg" >> $OUTPUT_CONFIG_FILE
echo "cache deny QUERY" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "acl store_rewrite_list url_regex ^http://(.*?)/get_video\?" >> $OUTPUT_CONFIG_FILE
echo "acl store_rewrite_list url_regex ^http://(.*?)/videodownload\?" >> $OUTPUT_CONFIG_FILE
echo "acl store_rewrite_list url_regex ^http://i(.*?).photobucket.com/albums/(.*?)/(.*?)/(.*?)\?" >> $OUTPUT_CONFIG_FILE
echo "acl store_rewrite_list url_regex ^http://vid(.*?).photobucket.com/albums/(.*?)/(.*?)\?" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "refresh_pattern ^http://(.*?)/get_video\? 1440 100% 1440 ignore-reload override-lastmod reload-into-ims override-expire ignore-no-cache ignore-private" >> $OUTPUT_CONFIG_FILE
echo "refresh_pattern ^http://(.*?)/videodownload\? 1440 100% 1440 ignore-reload override-lastmod reload-into-ims override-expire ignore-no-cache ignore-private" >> $OUTPUT_CONFIG_FILE
echo "refresh_pattern ^http://update.cabal.* 10080 100% 10080 ignore-reload override-lastmod reload-into-ims override-expire ignore-no-cache ignore-private" >> $OUTPUT_CONFIG_FILE
echo "refresh_pattern ^http://download.cabal.* 10080 100% 10080 ignore-reload override-lastmod reload-into-ims override-expire ignore-no-cache ignore-private" >> $OUTPUT_CONFIG_FILE
echo "refresh_pattern ^http://patch.sf.* 10080 100% 10080 ignore-reload override-lastmod reload-into-ims override-expire ignore-no-cache ignore-private" >> $OUTPUT_CONFIG_FILE
echo "refresh_pattern ^http://202.43.34.11 10080 100% 10080 ignore-reload override-lastmod reload-into-ims override-expire ignore-no-cache ignore-private" >> $OUTPUT_CONFIG_FILE
echo "refresh_pattern ^http://cbt.patch.easportsfifaonline2.in.th/.* 10080 100% 10080 ignore-reload override-lastmod reload-into-ims override-expire ignore-no-cache ignore-private" >> $OUTPUT_CONFIG_FILE  
echo "refresh_pattern ^http://patch.kr.in.th/.* 10080 100% 10080 ignore-reload override-lastmod reload-into-ims override-expire ignore-no-cache ignore-private" >> $OUTPUT_CONFIG_FILE
echo "refresh_pattern ^http://autopatch.sdo.in.th/patch/.* 10080 100% 10080 ignore-reload override-lastmod reload-into-ims override-expire ignore-no-cache ignore-private" >> $OUTPUT_CONFIG_FILE
echo "refresh_pattern ^http://update.hitsplay.com/.* 10080 100% 10080 ignore-reload override-lastmod reload-into-ims override-expire ignore-no-cache ignore-private" >> $OUTPUT_CONFIG_FILE
echo "refresh_pattern ^http://61.47.57.9/.* 10080 100% 10080 ignore-reload override-lastmod reload-into-ims override-expire ignore-no-cache ignore-private" >> $OUTPUT_CONFIG_FILE
echo "refresh_pattern ^http://www.titanonline.in.th/.* 10080 100% 10080 ignore-reload override-lastmod reload-into-ims override-expire ignore-no-cache ignore-private" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "# OPTIONS FOR TUNING THE CACHE" >> $OUTPUT_CONFIG_FILE
echo "# --------------------------------------" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "quick_abort_min 0 KB" >> $OUTPUT_CONFIG_FILE
echo "quick_abort_max 0 KB" >> $OUTPUT_CONFIG_FILE
echo "quick_abort_pct 100" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "half_closed_clients off" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "http_access deny blockweb" >> $OUTPUT_CONFIG_FILE
echo "http_access allow Manager all" >> $OUTPUT_CONFIG_FILE
echo "http_access deny Manager" >> $OUTPUT_CONFIG_FILE
echo "http_access allow All_Port" >> $OUTPUT_CONFIG_FILE
echo "http_access allow CONNECT All_Port" >> $OUTPUT_CONFIG_FILE
echo "http_access allow localhost" >> $OUTPUT_CONFIG_FILE
echo "http_access allow our_networks" >> $OUTPUT_CONFIG_FILE
echo "http_access deny all" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "http_reply_access allow all" >> $OUTPUT_CONFIG_FILE
echo "icp_access allow all" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "header_access Allow allow all" >> $OUTPUT_CONFIG_FILE
echo "header_access Authorization allow all" >> $OUTPUT_CONFIG_FILE
echo "header_access Cache-Control allow all" >> $OUTPUT_CONFIG_FILE
echo "header_access Content-Encoding allow all" >> $OUTPUT_CONFIG_FILE
echo "header_access Content-Length allow all" >> $OUTPUT_CONFIG_FILE
echo "header_access Content-Type allow all" >> $OUTPUT_CONFIG_FILE
echo "header_access Date allow all" >> $OUTPUT_CONFIG_FILE
echo "header_access Expires allow all" >> $OUTPUT_CONFIG_FILE
echo "header_access Host allow all" >> $OUTPUT_CONFIG_FILE
echo "header_access If-Modified-Since allow all" >> $OUTPUT_CONFIG_FILE
echo "header_access Last-Modified allow all" >> $OUTPUT_CONFIG_FILE
echo "header_access Location allow all" >> $OUTPUT_CONFIG_FILE
echo "header_access Pragma allow all" >> $OUTPUT_CONFIG_FILE
echo "header_access Accept allow all" >> $OUTPUT_CONFIG_FILE
echo "header_access Accept-Charset allow all" >> $OUTPUT_CONFIG_FILE
echo "header_access Accept-Encoding allow all" >> $OUTPUT_CONFIG_FILE
echo "header_access Accept-Language allow all" >> $OUTPUT_CONFIG_FILE
echo "header_access Content-Language allow all" >> $OUTPUT_CONFIG_FILE
echo "header_access Content-Language allow all" >> $OUTPUT_CONFIG_FILE
echo "header_access Mime-Version allow all" >> $OUTPUT_CONFIG_FILE
echo "header_access Retry-After allow all" >> $OUTPUT_CONFIG_FILE
echo "header_access Title allow all" >> $OUTPUT_CONFIG_FILE
echo "header_access Connection allow all" >> $OUTPUT_CONFIG_FILE
echo "header_access Proxy-Connection allow all" >> $OUTPUT_CONFIG_FILE
echo "header_access All allow all" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "cache allow store_rewrite_list" >> $OUTPUT_CONFIG_FILE
echo "cache allow all" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "storeurl_access allow store_rewrite_list" >> $OUTPUT_CONFIG_FILE
echo "storeurl_access deny all" >> $OUTPUT_CONFIG_FILE
echo "storeurl_rewrite_program /etc/squid/store_url_rewrite.pl" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "# OPTIONS WHICH AFFECT THE CACHE SIZE" >> $OUTPUT_CONFIG_FILE
echo "# -----------------------------------" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "cache_mem $SQUID_CACHE_MEM MB" >> $OUTPUT_CONFIG_FILE
echo "cache_swap_low 98" >> $OUTPUT_CONFIG_FILE
echo "cache_swap_high 99" >> $OUTPUT_CONFIG_FILE
echo "memory_pools on" >> $OUTPUT_CONFIG_FILE
echo "memory_pools_limit $SQUID_MEM_POOLS MB" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "maximum_object_size $SQUID_MAX_OBJ_SIZE MB" >> $OUTPUT_CONFIG_FILE
echo "maximum_object_size_in_memory $SQUID_MAX_OBJ_SIZE_MEM KB" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "ipcache_size 4096" >> $OUTPUT_CONFIG_FILE
echo "ipcache_low 98" >> $OUTPUT_CONFIG_FILE
echo "ipcache_high 99" >> $OUTPUT_CONFIG_FILE
echo "fqdncache_size 4096" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "cache_replacement_policy heap LFUDA" >> $OUTPUT_CONFIG_FILE
echo "memory_replacement_policy heap GDSF" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "# LOGFILE" >> $OUTPUT_CONFIG_FILE
echo "# -------------------------------------" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "cache_dir aufs /var/spool/squid $SQUID_CACHE_SIZE 24 256" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "logformat common %{%Y-%m-%d %H:%M:%S}tl %6tr %>a %Ss/%03Hs %<st %rm %ru %un %Sh/%<A %mt" >> $OUTPUT_CONFIG_FILE
echo "cache_access_log  /var/log/squid/common.log common" >> $OUTPUT_CONFIG_FILE
echo "cache_access_log  /var/log/squid/access.log" >> $OUTPUT_CONFIG_FILE
echo "cache_log /var/log/squid/cache.log" >> $OUTPUT_CONFIG_FILE
echo "cache_store_log none" >> $OUTPUT_CONFIG_FILE
echo "pid_filename /var/run/squid.pid" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "log_fqdn off" >> $OUTPUT_CONFIG_FILE
echo "client_netmask 255.255.255.255" >> $OUTPUT_CONFIG_FILE
echo "ftp_passive on" >> $OUTPUT_CONFIG_FILE
echo "ftp_sanitycheck on" >> $OUTPUT_CONFIG_FILE
echo "dns_nameservers 127.0.0.1" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "# ADMINISTRATIVE PARAMETERS" >> $OUTPUT_CONFIG_FILE
echo "# ------------------------------" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "cache_mgr squid@localhost" >> $OUTPUT_CONFIG_FILE
echo "visible_hostname cache.hadyaiinternet.com" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "# MISCELLANEOUS" >> $OUTPUT_CONFIG_FILE
echo "# -------------------------------" >> $OUTPUT_CONFIG_FILE
echo "log_icp_queries off" >> $OUTPUT_CONFIG_FILE
echo "query_icmp off" >> $OUTPUT_CONFIG_FILE
echo "buffered_logs off" >> $OUTPUT_CONFIG_FILE
echo "reload_into_ims on" >> $OUTPUT_CONFIG_FILE
echo "nonhierarchical_direct off" >> $OUTPUT_CONFIG_FILE
echo "prefer_direct on" >> $OUTPUT_CONFIG_FILE
echo "strip_query_terms off" >> $OUTPUT_CONFIG_FILE
echo "pipeline_prefetch on" >> $OUTPUT_CONFIG_FILE
echo "ie_refresh on" >> $OUTPUT_CONFIG_FILE
echo "forwarded_for on" >> $OUTPUT_CONFIG_FILE
echo "vary_ignore_expire on" >> $OUTPUT_CONFIG_FILE
echo "store_dir_select_algorithm round-robin" >> $OUTPUT_CONFIG_FILE
echo "ignore_unknown_nameservers on" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE
echo "#============================================================#" >> $OUTPUT_CONFIG_FILE
echo "# SNMP" >> $OUTPUT_CONFIG_FILE
echo "#============================================================#" >> $OUTPUT_CONFIG_FILE
echo "acl snmpcommunity snmp_community public" >> $OUTPUT_CONFIG_FILE
echo "snmp_port 3401" >> $OUTPUT_CONFIG_FILE
echo "snmp_access allow snmpcommunity localhost" >> $OUTPUT_CONFIG_FILE
echo "snmp_access deny all" >> $OUTPUT_CONFIG_FILE
echo >> $OUTPUT_CONFIG_FILE

echo "Make /etc/squid/squid.conf       ..done."
